import { world, system} from '@minecraft/server';
world.getDimension(`overworld`).runCommand(`tickingarea add circle 0 319 0 0 zeroChunk true`);
function cleanUp() {
    let list = world.getDimension("overworld").getEntities({ location: {x:8, y:317, z:8}, maxDistance: 1 })
    list.forEach((entity) => entity.teleport({x:8, y:-70, z:8}));
    world.getDimension(`overworld`).runCommand(`structure load cage 7 316 7 0_degrees none true true`);
}
cleanUp();
let bannerColor = ["black", "red", "green", "brown", "blue", "purple", "cyan", "light_gray", "gray", "pink", "lime", "yellow", "light_blue", "magenta", "orange", "white"];
function getPosition(location) {
    let x = location.x;
    let y = location.y;
    let z = location.z;
    return `${x} ${y} ${z} ${x} ${y} ${z}`;
}
function placeBannerPosition(location) {
    return `${location.x-2} 315 ${location.z-3}`
}
function placeBanner(placeLocation) {
    for(let i=0; i<16; i++) {
        let bannerData = world.getDimension("overworld").runCommand(`testfor @e[type=minecraft:hopper_minecart,hasitem={item=banner,data=${i},location=slot.inventory,slot=0}]`).successCount;
        if (bannerData){
            world.getDimension("overworld").runCommand(`structure load ${bannerColor[i]} ${placeBannerPosition(placeLocation)}`)
            cleanUp();
            break;
        }
    }
}
let player, currentItemHeld, blockInteracted;
world.beforeEvents.itemUseOn.subscribe( (e) => {
    player = e.source;
    currentItemHeld = e.itemStack;
    blockInteracted = e.block;
});
system.runInterval(
    () => {
        const itemCheck = world.getDimension("overworld").getEntities({location: {x:8, y:317, z:8}, maxDistance: 1  })[0]?.getComponent("inventory")?.container.getItem(0);
        if (itemCheck) { placeBanner(blockInteracted.location)};
        if (player && !player.isSneaking && blockInteracted?.typeId === "minecraft:standing_banner") {
            world.getDimension(`overworld`).runCommand(`clone ${getPosition(blockInteracted.location)} 8 318 8`);
            player = undefined;
        } else if(player && player.isSneaking && blockInteracted?.typeId === "minecraft:standing_banner") {
            world.getDimension(`overworld`).runCommand(`fill ${blockInteracted.x-2} 315 ${blockInteracted.z-3} ${blockInteracted.x+3} 315 ${blockInteracted.z+4} air`);
            player = undefined;
        } else {
            player = undefined;
            currentItemHeld = undefined;
            blockInteracted = undefined;
        };
    },
);